/*
 * Below are definitions of the functions that aren't in the standard library
 * that you need to implement.
 * We will compile and link these so that the initial wrapper functions for
 * them in your *.S file have something to wrap.  As far as I know, they are
 * some combination of having been written by Jed and having been borrowed from
 * K&R.
 */

#include <string.h>

void swap(int *a, int base1, int base2)
{
     int temp;
     temp = a[base1];
     a[base1] = a[base2];
     a[base2] = temp;
}

void bubblesort(int *a, int n)
{
     int outerloop = n - 1, innerloop, swapped;
     do
     {
          swapped = 0;
          for (innerloop = 0; innerloop < outerloop; innerloop++)
          {
               if (a[innerloop] > a[innerloop + 1])
               {
                    swap(a, innerloop, innerloop + 1);
                    swapped = 1;
               }
          }
          outerloop--;
     }
     while (swapped);
}

void reverse(char s[])
{
    int c, i, j;
    for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
        c = s[i];
        s[i] = s[j];
        s[j] = c;
    }
}

void itoa(int n, char s[])
{
    int i, sign;
    if ((sign = n) < 0)    /* record sign */
         n = -n;           /* make n positive */
    i = 0;
    do {         /* generate digits in reverse order */
         s[i++] = n % 10 + '0';    /* get next digit */
    } while ((n /= 10) > 0);       /* delete it */
    if (sign < 0)
         s[i++] = '-';
    s[i] = '\0';
    reverse(s);
}

