#include <sys/regdef.h>
#include <sys/syscall.h>

// You may delete this macro when you no longer need it.
// It essentially just calls the given function, passing on whatever arguments
// are in the a# registers, and then passes back whatever return values are in
// the v# registers.  Don't worry--you don't have to understand this.
#define WRAP_CALL(func)             \
    addiu   sp, sp, -24             ;\
    sw      ra, 20(sp)              ;\
    sw      gp, 16(sp)              ;\
    lw      t9, %call16(func)(gp)   ;\
    jalr    t9                      ;\
    lw      gp, 16(sp)              ;\
    lw      ra, 20(sp)              ;\
    addiu   sp, sp, 24              ;\
    jr      ra

.text

// char *my_strcpy( char *dest, const char *src );
    .globl  my_strcpy
    .ent    my_strcpy
my_strcpy:
    WRAP_CALL(strcpy)
    .end    my_strcpy


// char *my_strcat( char *dest, const char *src );
    .globl  my_strcat
    .ent    my_strcat
my_strcat:
    WRAP_CALL(strcat)
    .end    my_strcat


// int my_puts( const char *s );
    .globl  my_puts
    .ent    my_puts
my_puts:
    WRAP_CALL(puts)
    .end    my_puts


// int my_strcmp( const char *s1, const char *s2 );
    .globl  my_strcmp
    .ent    my_strcmp
my_strcmp:
    WRAP_CALL(strcmp)
    .end    my_strcmp


// size_t my_strlen( const char *s );
    .globl  my_strlen
    .ent    my_strlen
my_strlen:
    WRAP_CALL(strlen)
    .end    my_strlen


// void my_itoa( int n, char s[] );
    .globl  my_itoa
    .ent    my_itoa
my_itoa:
    WRAP_CALL(itoa)
    .end    my_itoa


// void my_reverse( char s[] );
    .globl  my_reverse
    .ent    my_reverse
my_reverse:
    WRAP_CALL(reverse)
    .end    my_reverse


// void my_bubblesort( int *a, int n );
    .globl  my_bubblesort
    .ent    my_bubblesort
my_bubblesort:
    WRAP_CALL(bubblesort)
    .end    my_bubblesort


// void my_swap( int *a, int base1, int base2 );
    .globl  my_swap
    .ent    my_swap
my_swap:
    WRAP_CALL(swap)
    .end    my_swap
